# Nuxt.js JSON API Example

This is a Nuxt.js application that demonstrates integration with a JSON API. It provides functionality for viewing and creating articles.

## Features

- View list of articles
- Create new articles
- Tag-based filtering
- Responsive design with Tailwind CSS
- TypeScript support

## Prerequisites

- Node.js 18 or later
- npm or pnpm

## Setup

1. Install dependencies:
```bash
npm install
# or
pnpm install
```

2. Create a `.env` file in the root directory with your API configuration:
```
API_BASE=http://localhost:3000
```

3. Start the development server:
```bash
npm run dev
# or
pnpm dev
```

## Project Structure

- `components/` - Vue components
- `layouts/` - Page layouts
- `pages/` - Application pages
- `types/` - TypeScript type definitions
- `assets/` - Static assets and styles

## API Integration

The application expects a JSON API that follows the JSON:API specification. The API should provide the following endpoints:

- `GET /articles` - List all articles
- `POST /articles` - Create a new article

## Development

- `npm run dev` - Start development server
- `npm run build` - Build for production
- `npm run generate` - Generate static site
- `npm run preview` - Preview production build

## License

MIT 